<?php

namespace Drupal\personality_test\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\node\Entity\Node;
use Drupal\personality_test\Options;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Controller for Personality-Test.
 *
 * @category CategoryName
 * @package YourPackageName
 * @author Your Name <your_email@example.com>
 * @license https://www.example.com/license YourLicenseName
 * @link https://www.example.com
 * @since PHP 7.4.0
 */
class PersonalityTestController extends ControllerBase {

  /**
   * Returns content for the Personality Test.
   *
   * @param \Symfony\Component\HttpFoundation\Request $request
   *   The request object.
   *
   * @return \Symfony\Component\HttpFoundation\JsonResponse
   *   Response JSON or renderable array.
   */
  public function content(Request $request) {
    if ($request->getMethod() === 'POST') {
      $content = $request->getContent();
      $data = json_decode($content, TRUE);
      if (isset($data['finalResult'])) {
        $hello = $data['finalResult'];
        $user_id = \Drupal::currentUser()->id();
        $node = Node::create(
              [
                'type' => 'personality_assessment_test',
                'title' => 'Personality Assessment Result',
                'field_personality_test_user_id' => $user_id,
                'field_personality_test_result' => [
                  'value' => $content,
                  'format' => 'full_html',
                ],
              ]
          );
        $node->save();
        return new JsonResponse(['finalResult' => $hello]);
      }
      else {
        return new JsonResponse(['error' => 'error'], 400);
      }
    }
    elseif ($request->getMethod() === 'GET') {
      $data = Options::getSampleData();
      $block_content = \Drupal::service('plugin.manager.block')
        ->createInstance('personality_test_quiz_block')
        ->build();
      $build = [
        '#theme' => 'personality_test_quiz',
        '#questions' => $data['questions'],
        '#personality_test_block_content' => $block_content,
      ];
      return $build;
    }
    else {
      return new JsonResponse(['error' => 'Invalid request method'], 400);
    }
  }

}
